- block:
  - include_role:
      name: commons
      tasks_from: helpers/volume.yaml
    vars:
      vol_name: "{{ ara_pg_name }}-{{ target }}-snap"
      vol_size: "{{ ara_db_data_capacity }}"
  - name: Marks operation in progress
    set_fact:
      snap_failed: True
    when:
    - has_pvc is defined
    - has_pvc.resources is defined
    - (has_pvc.resources | length) > 0
  - name: Scales Gitea down to 0
    async: 30
    k8s:
      definition:
        apiVersion: "{{ deployment_apivers }}"
        kind: "{{ deployment_kind }}"
        metadata:
          name: "{{ ara_name }}"
          namespace: "{{ namespace }}"
        spec:
          replicas: 0
    poll: 5
    when:
    - (snap_failed | default(False)) == False
  - include_role:
      name: commons
      tasks_from: snapshots/postgres.yaml
    vars:
      db_data_capacity: "{{ ara_db_data_capacity }}"
      db_host: "{{ ara_pg_name }}"
      db_secret_name: "{{ ara_pg_name }}"
      job_assume_pod_netpol: "{{ ara_name }}"
      provision_volume: False
      snap_mark: "{{ target }}"
  - name: Lookups Postgres Snapshot Job
    async: 30
    changed_when: False
    k8s_info:
      api_version: batch/v1
      kind: Job
      namespace: "{{ namespace }}"
      name: "{{ ara_pg_name }}-{{ target }}-snap"
    no_log: True
    poll: 5
    register: pg_snap
    when:
    - (snap_failed | default(False)) == False
  - block:
    - name: Reverts Upgrade when snapshot failed
      async: 30
      k8s:
        definition:
          apiVersion: "{{ deployment_apivers }}"
          kind: "{{ deployment_kind }}"
          metadata:
            name: "{{ ara_name }}"
            namespace: "{{ namespace }}"
          spec:
            replicas: 1
      poll: 5
    - name: Fails when snapshot failed
      fail:
        msg: "Failed upgrading ARA to {{ target }}"
    when:
    - >
        snap_failed | default(False)
        or (pg_snap is defined
            and pg_snap.resources is defined
            and (pg_snap.resources | length == 0
                 or (pg_snap.resources[0].status is defined
                     and pg_snap.resources[0].status is defined
                     and (pg_snap.resources[0].status.completionTime is not defined
                          or (not ((pg_snap.resources[0].status.succeeded | default(0)) in [ 1, '1' ]))))))
  when:
  - do_backups
- block:
  - include_role:
      name: commons
      tasks_from: helpers/deployment.yaml
    vars:
      cone_cpu_limit: "{{ authproxy_cpu_limit }}"
      cone_cpu_request: "{{ authproxy_cpu_request }}"
      cone_idx: "{{ 1 if (do_lemon or do_ldap)
                      else 0 }}"
      cone_memory_limit: "{{ authproxy_memory_limit }}"
      cone_memory_request: "{{ authproxy_memory_request }}"
      cone_tag: "{{ authproxy_tag }}"
      cpu_limit: "{{ ara_cpu_limit }}"
      cpu_request: "{{ ara_cpu_request }}"
      dc_data: "{{ lookup('template', 'ara.j2') }}"
      dc_name: "{{ ara_name }}"
      dc_replicas: "{{ ara_replicas }}"
      dc_tag: "{{ target }}"
      exporter_idx: "{{ 2 if (do_lemon or do_ldap)
                          else 0 }}"
      exporter_tag: "{{ httpexporter_tag }}"
      memory_limit: "{{ ara_memory_limit }}"
      memory_request: "{{ ara_memory_request }}"
    when:
    - (snap_failed | default(False)) == False
  - include_role:
      name: commons
      tasks_from: helpers/wait-for.yaml
    vars:
      check_with: "{{ lookup('k8s', api_version=deployment_apivers,
                             kind=deployment_kind, namespace=namespace,
                             resource_name=ara_name) | default('') }}"
      obj_name: "{{ ara_name }}"
      retries_for: 60
      wait_for: 10
    when:
    - (snap_failed | default(False)) == False
    - dc_started is defined
    - dc_started is changed
  - name: Checks ARA Upgrade Status
    async: 30
    changed_when: False
    k8s_info:
      api_version: "{{ deployment_apivers }}"
      kind: "{{ deployment_kind }}"
      name: "{{ ara_name }}"
      namespace: "{{ namespace }}"
    no_log: True
    poll: 5
    register: has_ara
    when:
    - (snap_failed | default(False)) == False
  - name: Fails when upgrade is still running
    fail:
      msg: "Failed upgrading Gitea to {{ target }}"
    when:
    - has_ara is defined
    - has_ara.resources is defined
    - has_ara.resources | length > 0
    - has_ara.resources[0].status is defined
    - has_ara.resources[0].status.readyReplicas is defined
    - has_ara.resources[0].status.readyReplicas == 0
  when:
  - not (snap_failed | default(False))
